package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.Calendar;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;

import com.rjconsultores.ventaboletos.entidad.PacoteConvenio;
import com.rjconsultores.ventaboletos.service.PacoteConvenioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;

@Controller("editarPacoteConvenioController")
@Scope("prototype")
public class EditarPacoteConvenioController extends MyGenericForwardComposer {

	private static Logger log = Logger.getLogger(EditarPacoteConvenioController.class);
	
	private static final long serialVersionUID = 1L;

	@Autowired
    private PacoteConvenioService pacoteConvenioService;
    private PacoteConvenio pacoteConvenio;
    private MyListbox pacoteConvenioList;
    private Button btnApagar;
    private MyTextbox txtNomconvenio;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);
        pacoteConvenio = (PacoteConvenio) Executions.getCurrent().getArg().get("pacoteConvenio");
        pacoteConvenioList = (MyListbox) Executions.getCurrent().getArg().get("pacoteConvenioList");

        if (pacoteConvenio.getPacoteconvenioId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNomconvenio.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNomconvenio.getValue();

        try {
            pacoteConvenio.setActivo(Boolean.TRUE);
            pacoteConvenio.setFecmodif(Calendar.getInstance().getTime());
            pacoteConvenio.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            if (pacoteConvenio.getPacoteconvenioId() == null) {
                pacoteConvenioService.suscribir(pacoteConvenio);
                pacoteConvenioList.addItemNovo(pacoteConvenio);
            } else {
                pacoteConvenioService.actualizacion(pacoteConvenio);
                pacoteConvenioList.updateItem(pacoteConvenio);
            }

            Messagebox.show(
                    Labels.getLabel("editarPacoteConvenioController.MSG.suscribirOK"),
                    Labels.getLabel("editarPacoteConvenioController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            closeWindow();
        } catch (Exception ex) {
            log.error("editarPacoteConvenioController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarPacoteConvenioController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPacoteConvenioController.MSG.borrarPergunta"),
                    Labels.getLabel("editarPacoteConvenioController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                pacoteConvenioService.borrar(pacoteConvenio);

                Messagebox.show(
                        Labels.getLabel("editarPacoteConvenioController.MSG.borrarOK"),
                        Labels.getLabel("editarPacoteConvenioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                pacoteConvenioList.removeItem(pacoteConvenio);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

	public MyTextbox getTxtNomconvenio() {
		return txtNomconvenio;
	}

	public void setTxtNomconvenio(MyTextbox txtNomconvenio) {
		this.txtNomconvenio = txtNomconvenio;
	}

	public PacoteConvenio getPacoteConvenio() {
		return pacoteConvenio;
	}

	public void setPacoteConvenio(PacoteConvenio pacoteConvenio) {
		this.pacoteConvenio = pacoteConvenio;
	}
    
}
